unit FSfx;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ResStore, FileCtrl, Buttons;

type
  TFenSelectExtractPath = class(TForm)
    Button1: TButton;
    StoredFiles: TRessourceStore;
    EditDirectory: TEdit;
    LabelFileName: TLabel;
    btnOk: TBitBtn;
    btnCancel: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FenSelectExtractPath: TFenSelectExtractPath;

implementation

{$R *.DFM}

procedure TFenSelectExtractPath.FormCreate(Sender: TObject);
var S: string;
    L: Integer;
begin
  SetLength(S, MAX_PATH + 1);
  L:= GetCurrentDirectory(MAX_PATH, PChar(S));
  SetLength(S, L);
  EditDirectory.Text:= S;
end;

procedure TFenSelectExtractPath.Button1Click(Sender: TObject);
var S: string;
begin
  S:= EditDirectory.Text;
  if SelectDirectory(S, [sdAllowCreate, sdPerformCreate, sdPrompt], 0) then
    EditDirectory.Text:= S;
end;

procedure TFenSelectExtractPath.btnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TFenSelectExtractPath.btnOkClick(Sender: TObject);
var i: Integer;
    Path: string;
begin
  Path:= Trim(EditDirectory.Text);
  if Path = '' then
    raise Exception.Create('No directory selected !!');
  if Path[Length(Path)] <> '\' then Path:= Path + '\';
  Screen.Cursor:= crHourglass;
  try
    for i:= 0 to StoredFiles.Items.Count - 1 do
      with StoredFiles.Items[i] do
      begin
        LabelFileName.Caption:= Name;
        Application.ProcessMessages;
        SaveToFile(Path + Name);
      end;
  finally
    Close;
  end;
end;

end.
